import { AndroidPermission } from 'react-native-permissions';
import { EffectCallback } from 'react';
import { IOSPermission } from 'react-native-permissions';
import { PermissionStatus as PermissionStatus_2 } from 'react-native-permissions';
import { WindowsPermission } from 'react-native-permissions';

declare interface AppActiveInterval {
    /**
     * 设置 setInterval 是否运行
     * @param active
     */
    setActive: (active: boolean) => void;
}

declare interface AppActiveIntervalOptions {
    /**
     * setInterval 是否运行
     *
     * @default true
     */
    active?: boolean;
}

declare interface PageEventEmitterParams {
    /**
     * 运行事件
     */
    emit: () => void;
}

declare type PageGestureEnabledParams = {
    setEnabled: (enabled: boolean) => void;
};

declare interface PageInterval {
    /**
     * 设置 setInterval 是否运行
     * @param active
     */
    setActive: (active: boolean) => void;
}

declare interface PageIntervalOptions {
    /**
     * setInterval 是否运行
     *
     * @default true
     */
    active?: boolean;
}

declare type Permission = IOSPermission | AndroidPermission | WindowsPermission;

declare type Permission_2 = IOSPermission | AndroidPermission | WindowsPermission;

export declare const permissions: {
    request: (permissions: Permissions_3, permissionStatus?: "unavailable" | "blocked" | "denied" | "granted" | "limited") => RequestResponse_2;
};

declare type Permissions_2 = Permission[];

declare type Permissions_3 = Permission_2[];

declare type PermissionsParams = {
    state: State;
    request: () => RequestResponse;
};

declare type RequestResponse = Promise<void | {
    openSettings: Promise<void>;
}>;

declare type RequestResponse_2 = Promise<void | {
    openSettings: Promise<void>;
}>;

declare type State = boolean | null;

export declare const useAppActiveInterval: (effect: EffectCallback, ms: number, options?: AppActiveIntervalOptions) => AppActiveInterval;

export declare const usePageEventEmitter: (key: string, effect?: EffectCallback | undefined) => PageEventEmitterParams;

export declare const usePageGestureEnabled: (enabled: boolean) => PageGestureEnabledParams;

export declare const usePageInterval: (effect: EffectCallback, ms: number, options?: PageIntervalOptions) => PageInterval;

export declare const usePermissions: (permissions: Permissions_2, permissionStatus?: PermissionStatus_2) => PermissionsParams;

export { }
